<script setup lang="ts">
import { useCustomerStore } from '@/stores/customer'
import { useReceiptStore } from '@/stores/receipt'
import { ref } from 'vue'
import CustomerEditCard from './CustomerEditCard.vue'
const tel = ref('')
const customerStore = useCustomerStore()
const receiptStore = useReceiptStore()
function onClick() {
  customerStore.searchMember(tel.value)
  receiptStore.calReceipt()
}

const usePoint = ref<number>(0)
const totalPoint = ref<number>(0)
const earnPoint = ref<number>(0)

function calTotalPoint(): number {
  if (customerStore.currentCustomer) {
    earnPoint.value = receiptStore.receipt.totalBefore * customerStore.currentCustomer.pointRate
    totalPoint.value = earnPoint.value + customerStore.currentCustomer.pointAmount - usePoint.value
    receiptStore.receipt.PointDiscount = usePoint.value
    receiptStore.calReceipt()
  }
  return totalPoint.value
}
</script>
<template>
  <v-container>
    <v-row>
      <v-col cols="3" class="pt-1 pb-0">
        <h2>Customer</h2>
      </v-col>
      <v-col cols="6" class="pa-3 pl-8 pt-0 pb-0 text-center">
        <v-text-field
          density="compact"
          variant="solo"
          label="Search"
          append-inner-icon="mdi-magnify"
          v-model="tel"
          single-line
          hide-details
          @click:append-inner="onClick"
          @keyup.enter="onClick"
          style="width: 150px; min-height: 10px"
          bg-color="rgb(251, 206, 206)"
          rounded
        ></v-text-field>
      </v-col>
      <v-col cols="3" class="pa-4 text-center pt-2 pb-0" v-model="customerStore.dialog">
        <v-dialog v-model="customerStore.dialog" persistent width="1024">
          <template v-slot:activator="{ props }">
            <v-btn
              icon="mdi-account-plus"
              density="comfortable"
              size="small"
              style="background-color: greenyellow; width: 30px"
              v-bind="props"
            ></v-btn>
          </template>
        </v-dialog>
      </v-col>
      <v-col cols="12" class="pa-0 pl-4 text-center pt-2">
        <div style="text-align: left">
          Member Name :
          {{ customerStore.currentCustomer ? customerStore.currentCustomer?.name : 'ไม่พบผู้ใช้' }}
        </div>
      </v-col>
      <v-col cols="6" class="pa-0 pl-4 text-center pt-0">
        <div style="text-align: left">Member Point :</div>
      </v-col>
      <v-col cols="6" class="pa-0 pl-4 pt-0" style="text-align: right; padding-right: 30px">
        <div style="padding-right: 40px">
          {{ customerStore.currentCustomer?.pointAmount.toFixed(2) }}
        </div>
      </v-col>
      <v-col cols="6" class="pa-0 pl-4 text-center pt-0">
        <div style="text-align: left">Use :</div>
      </v-col>
      <v-col cols="6" class="pa-0 pl-4 pt-0" style="text-align: right">
        <div style="padding-right: 30px">
          <input
            type="number"
            id="pointInput"
            style="width: 50px; min-height: 10px; text-align: right"
            min="0"
            :max="customerStore.currentCustomer?.pointAmount"
            v-model="usePoint"
          />
        </div>
      </v-col>
      <v-col cols="6" class="pa-0 pl-4 text-center pt-0">
        <div style="text-align: left">Earn :</div>
      </v-col>
      <v-col cols="6" class="pa-0 pl-4 pt-0" style="text-align: right">
        <div style="padding-right: 40px">
          {{ earnPoint.toFixed(2) }}
        </div>
      </v-col>
      <v-col cols="6" class="pa-0 pl-4 text-center">
        <div style="text-align: left">Total Point :</div> </v-col
      ><v-col cols="6" class="pa-0 pl-4" style="text-align: right">
        <div style="padding-right: 40px">{{ calTotalPoint().toFixed(2) }}</div>
      </v-col>
    </v-row>
  </v-container>
  <CustomerEditCard></CustomerEditCard>
</template>
